﻿/// <reference path="../GeneratedArtifacts/viewModel.js" />

myapp.GanttChart.GanttChartView_render = function (element, contentItem) {
    // Prepare user interface element.
    var ganttChartViewElement = $("<div style='height: 640px'>...</div>");
    $(ganttChartViewElement).appendTo($(element));
    var ganttChartView = ganttChartViewElement[0];

    // Load data (asynchronous operation).
    var tasks = contentItem.value;
    tasks.load().then(function (taskCount) {
        // Prepare items.
        var items = [];
        for (var i = 0; i < taskCount; i++) {
            var task = tasks.data[i];
            var item = {
                content: task.Name, indentation: task.Indentation, start: task.Start, finish: task.Finish, completedFinish: task.Completion, isMilestone: task.IsMilestone, assignmentsContent: task.Assignments != null ? task.Assignments : "",
                tag: task
            };
            items.push(item);
        }

        // Initialize component after finalizing current rendering preparations.
        setTimeout(function () {
            var settings = {
                displayedTime: items.length > 0 ? items[0].start : new Date(),
                areTaskDependenciesVisible: false
            };
            DlhSoft.Controls.GanttChartView.initialize(ganttChartView, items, settings);

            // Propagate item changes to data entities.
            settings.itemPropertyChangeHandler = function (item, propertyName, isDirect, isFinal) {
                if (propertyName == "isSelected" || !isFinal)
                    return;
                var task = item.tag;
                switch (propertyName) {
                    case "content":
                        task.Name = item.content;
                        break;
                    case "start":
                        task.Start = DlhSoft.Controls.GanttChartView.getOutputDate(item.start);
                        break;
                    case "finish":
                        task.Finish = DlhSoft.Controls.GanttChartView.getOutputDate(item.finish);
                        break;
                    case "completedFinish":
                        task.Completion = DlhSoft.Controls.GanttChartView.getOutputDate(item.completedFinish);
                        break;
                    case "isMilestone":
                        task.IsMilestone = item.isMilestone;
                        break;
                    case "assignmentsContent":
                        task.Assignments = item.assignmentsContent;
                        break;
                }
            }
        }, 0);
    });
};